-- file YGREC8/VHDL/ALU8/ALU8.vhdl
-- created jeu. janv.  2 03:18:26 CET 2020 by whygee@f-cpu.org
--
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;
Library SLV;
    use SLV.SLV_def.all;

entity ALU8 is
  port(
    Cin, NEG, CMPS, PASS_en, AND_en, XOR_en, OrXor_en : in SL;
    SRI, SND : in SLV8;
    ROP, SUM : inout SLV8;
    Cout : out SL);
end ALU8;

architecture ASIC of ALU8 is
  Signal P, nP, G, nG, S, X : SLV8;
begin

  eROP2: entity ROP2 port map (
          SRI => SRI,
          SND => SND,
          NEG => NEG,
      PASS_en => PASS_en,
       AND_en => AND_en,
       XOR_en => XOR_en,
     OrXor_en => OrXor_en,
         ROP2 => ROP,
           nG => nG,
           nP => nP,
            G => G,
            P => P,
            X => X);

  eCLA8: entity CLA8 port map (  -- zombies: 
             nG => nG,           -- 5
             nP => nP,           -- 6,7
              G => G,            -- 2, 4, 7
              P => P,            -- 5
              X => X,
        CarryIn => Cin,
           CMPS => CMPS,
            SUM => SUM,
       CarryOut => Cout);

end ASIC;
