-- YGREC8/VHDL/ALU8/Wrap_CLA8.vhdl
-- version jeu. janv.  2 03:39:38 CET 2020
--
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;

entity VG_Wrapper is
  generic (
    -- overridden by the VG code so it doesn't matter that much
    VectGenWidthIn : integer := 43;
    VectGenWidthOut: integer := 10
  );
  port(
    VectIn : in  std_logic_vector(VectGenWidthIn -1 downto 0);
    VectOut: inout std_logic_vector(VectGenWidthOut-1 downto 0);
    VectClk: in std_logic
  );
end VG_Wrapper;

architecture Wrap_CLA8 of VG_Wrapper is
begin

  dut: entity CLA8 port map (
    -- here we "wire" the unit to the Vector Generator ports:
                                           -- zombies:
             nP => VectIn ( 7 downto  0),  -- 6,7
             nG => VectIn (15 downto  8),  -- 5
              P => VectIn (23 downto 16),  -- 5
              G => VectIn (31 downto 24),  -- 2, 4, 7
              X => VectIn (39 downto 32),  -- 
        CarryIn => VectIn (40),
           CMPS => VectIn (41),

            SUM => VectOut( 7 downto 0),
       CarryOut => VectOut( 8));

  -- the wires that enable size autodetection
  VectOut(9) <= '1';
  VectOut(VectGenWidthOut-1) <= VectIn(42);
end Wrap_CLA8;
