-- YGREC8/VHDL/ALU8/Wrap_ROP2.vhdl
-- version mer. janv.  1 15:57:30 CET 2020
--
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;

entity VG_Wrapper is
  generic (
    -- overridden by the VG code so it doesn't matter that much
    VectGenWidthIn : integer := 22;
    VectGenWidthOut: integer := 49
  );
  port(
    VectIn : in  std_logic_vector(VectGenWidthIn -1 downto 0);
    VectOut: inout std_logic_vector(VectGenWidthOut-1 downto 0);
    VectClk: in std_logic
  );
end VG_Wrapper;

architecture Wrap_ROP2 of VG_Wrapper is
begin

  dut: entity ROP2 port map (
    -- here we "wire" the unit to the Vector Generator ports:
          SRI => VectIn ( 7 downto 0),
          SND => VectIn (15 downto 8),
          NEG => VectIn(16),
      PASS_en => VectIn(17),
       AND_en => VectIn(18),
       XOR_en => VectIn(19),
     OrXor_en => VectIn(20),
    ROP2 => VectOut( 7 downto 0),
      nG => VectOut(15 downto 8),
      nP => VectOut(23 downto 16),
       G => VectOut(31 downto 24),
       P => VectOut(39 downto 32),
       X => VectOut(47 downto 40));

  -- the wires that enable size autodetection
  VectOut(48) <= '1';
  VectOut(VectGenWidthOut-1) <= VectIn(21);
end Wrap_ROP2;
