#!/bin/bash
# file ALU8/test.sh
# created mar. déc. 31 00:11:19 CET 2019 by Yann Guidon / ygdes.com
# version mer. janv.  1 17:05:28 CET 2020
# version dim. nov. 14 08:18:36 CET 2021
#
# Released under the GNU AGPLv3 license

PA3="-P../gates -P../shared"

echo "checking the ROP2 functionality:" &&
rm -f *.cf *.o test_rop2 &&
ghdl -a $PA3 ROP2_ASIC.vhdl test_ROP2.vhdl &&
ghdl -e $PA3 test_ROP2 &&
./test_rop2 |sed 's/.*(report note)://' &&

echo "checking the ROP2's netlist:" &&
rm -f *.cf *.o test_rop2 vectgen &&
ghdl -a $PA3 ROP2_ASIC.vhdl Wrap_ROP2.vhdl ../gates/VectGen.vhdl &&
ghdl -e $PA3 VectGen &&
./vectgen |sed 's/.*(report note)://' &&
rm -f *.cf *.o vectgen &&
echo $'\e[32m'"ROP2 : OK !"$'\e[0m' &&
echo &&

echo "Now checking the CLA's netlist:" &&
rm -f *.cf *.o &&
ghdl -a $PA3 gate_CLA3b.vhdl gate_CLA3bn.vhdl \
   CLA8_ASIC.vhdl Wrap_CLA8.vhdl ../gates/VectGen.vhdl &&
ghdl -e $PA3 VectGen &&
./vectgen |sed 's/.*(report note)://' &&
rm -f *.cf *.o vectgen &&

echo $'\e[32m'"CLA8 : OK !"$'\e[0m' &&
echo &&

ghdl -a $PA3 gate_CLA3b.vhdl gate_CLA3bn.vhdl CLA8_ASIC.vhdl \
    ROP2_ASIC.vhdl ALU8.vhdl Wrap_ALU8.vhdl ../gates/VectGen.vhdl &&
ghdl -e $PA3 VectGen &&
./vectgen |sed 's/.*(report note)://' &&
rm -f *.cf *.o vectgen &&

ghdl -a $PA3 ../ASM/ygrec8_asm.vhdl gate_CLA3b.vhdl gate_CLA3bn.vhdl \
    CLA8_ASIC.vhdl ROP2_ASIC.vhdl ALU8.vhdl dec_ALU8.vhdl test_decoder.vhdl &&
ghdl -e $PA3 test_decoder &&
./test_decoder | grep -v '(report note):' &&

echo $'\e[32m'"ALU8 : OK !"$'\e[0m' && echo
