-- YGREC8/VHDL/ALU8/test_ROP2.vhdl
-- created lun. déc. 30 19:48:33 CET 2019 by whygee@f-cpu.org
--
-- Released under the GNU AGPLv3 license
--
--        NEG  PASS_en AND_en XOR_en OrXor_en
-- OR      0       0      0      0      1
-- XOR     0       0      1      1      1
-- AND     0       0      0      1      0
-- ANDN    1       0      0      1      0
-- SUB     1       0      1      x      0      
-- ADD     0       0      1      x      0
-- PASS    x       1      1      x      0
-- clear   x       0      0      0      0

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;
Library SLV;
    use SLV.SLV_def.all;
Library proasic3;
    use proasic3.all;
Library conversions;
    use conversions.conversions.all;

entity test_ROP2 is
end test_ROP2;

architecture test of test_ROP2 is
  signal NEG, PASS_en, AND_en, XOR_en, OrXor_en : SL;
  signal SRI, SND, ROP, G, P, nG, nP, X : SLV8;
begin

  tb: entity ROP2 port map (
         NEG => NEG,
     PASS_en => PASS_en,
      AND_en => AND_en,
      XOR_en => XOR_en,
    OrXor_en => OrXor_en,
         SRI => SRI,
         SND => SND,
        ROP2 => ROP,
          nG => nG,
           G => G,
          nP => nP,
           P => P,
           X => X);

  process is
    procedure display_outputs(a, b, c, d, e: SL; s: string) is
    begin
           NEG <= a;
       PASS_en <= b;
        AND_en <= c;
        XOR_en <= d;
      OrXor_en <= e;

      wait for 1 sec;

      report s
           & " NEG=" & std_logic'image(NEG)(2)
          & " PASS=" & std_logic'image(PASS_en)(2)
           & " AND=" & std_logic'image(AND_en)(2)
           & " XOR=" & std_logic'image(XOR_en)(2)
         & " OrXor=" & std_logic'image(OrXor_en)(2)
           & " SRI=" & SLV_to_bin(SRI)
           & " SND=" & SLV_to_bin(SND)
        & " - ROP2=" & SLV_to_bin(ROP)
             & " G=" & SLV_to_bin(G)
             & " P=" & SLV_to_bin(P)
             & " X=" & SLV_to_bin(X) ;
    end procedure;

  begin
    report "Starting test of ROP2 unit";

    SRI <= "00001010";
    SND <= "00001100";

    display_outputs('0', '0', '0', '0', '1', "OR   ");

    display_outputs('0', '0', '1', '1', '1', "XOR  ");

    display_outputs('0', '0', '0', '1', '0', "AND  ");

    display_outputs('1', '0', '0', '1', '0', "ANDN ");

    display_outputs('1', '0', '1', '0', '0', "SUB  ");
    display_outputs('1', '0', '1', '1', '0', "SUB  ");

    display_outputs('0', '0', '1', '0', '0', "ADD  ");
    display_outputs('0', '0', '1', '1', '0', "ADD  ");

    display_outputs('0', '1', '1', '1', '0', "PASS1");
    display_outputs('0', '1', '1', '0', '0', "PASS2");
    display_outputs('1', '1', '1', '1', '0', "PASS3");
    display_outputs('1', '1', '1', '0', '0', "PASS4");

    display_outputs('0', '0', '0', '0', '0', "clear");
    display_outputs('1', '0', '0', '0', '0', "clear");
    
    wait;
  end process;

end test;
