-- file YGREC8/ASM/disasm_tb.vhdl
-- created jeu. mars 14 16:12:43 CET 2019 by Yann Guidon / ygdes.com
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
Library work;
    use work.all;
    use work.ygrec8_asm.all;
Library SLV;
    use SLV.SLV_def.all;
Library YGREC8;
    use YGREC8.ygrec8_def.all;
Library conversions;
    use conversions.conversions.all;

entity disasm_tb is
end disasm_tb;

architecture test of disasm_tb is
begin

  bench: process
    variable i: integer := 0;
    variable expected : SLV16;
    variable tmp: string(1 to 18);
    variable strbin: string(1 to 16);

  begin
    report CR & LF & CR & LF & "Testing ALL the possible instructions:" ;

    test_all_instruction: loop
      expected := std_logic_vector(to_unsigned(i,16));
      strbin:=SLV_to_bin(expected);
      Disassemble(expected, strbin, tmp) ; 
      report  strbin & " : " & tmp & " " & integer'image(i) ;
      i := i+1;
      exit when i>65535;
    end loop test_all_instruction;
    wait;
  end process;

end test;
