-- YGREC8/VHDL/TAP/MUX64/MUX16_A.vhdl
-- created mar. juil. 21 21:07:06 CEST 2020 by whygee@f-cpu.org
-- version mar. juil. 21 23:01:34 CEST 2020 : classic
-- version mar. juil. 21 23:25:19 CEST 2020 : gates
-- version mer. juil. 22 00:04:51 CEST 2020 : gates reduced to 16 bits
--
-- Released under the GNU AGPLv3 license
--
-- Trivial MUX16 mapped to gates.
-- see BBT_MUX16a.svg

Library ieee;
    use ieee.std_logic_1164.all;
Library SLV;
    use SLV.SLV_def.all;
Library proasic3;
    use proasic3.all;

entity MUX16 is
  port(
    leaves : in SLV16;
    CTRL : in SLV4;
    root : out SL);
end MUX16;

architecture gates of MUX16 is
  signal L4 : SLV8;
  signal L3 : SLV4;
  signal L2 : SLV2;
begin
                                  l1x: entity MX2 port map(A=>    L2(0), B=>    L2(1)          , S=>CTRL(0), Y=>root);
  l2g: for i in L2'range generate l2x: entity MX2 port map(A=>    L3(i), B=>    L3(i+L2'length), S=>CTRL(1), Y=>L2(i)); end generate l2g;
  l3g: for i in L3'range generate l3x: entity MX2 port map(A=>    L4(i), B=>    L4(i+L3'length), S=>CTRL(2), Y=>L3(i)); end generate l3g;
  l4g: for i in L4'range generate l4x: entity MX2 port map(A=>leaves(i), B=>leaves(i+L4'length), S=>CTRL(3), Y=>L4(i)); end generate l4g;
end gates;
