-- YGREC8/VHDL/TAP/MUX64/MUX16_B.vhdl
-- created mar. juil. 21 21:07:06 CEST 2020 by whygee@f-cpu.org
-- version mar. juil. 21 23:01:34 CEST 2020 : classic
-- version mar. juil. 21 23:25:19 CEST 2020 : gates
-- version mer. juil. 22 00:04:51 CEST 2020 : gates reduced to 16 bits
-- version mer. juil. 22 15:06:03 CEST 2020 : MUX16 balanced control
--
-- Released under the GNU AGPLv3 license
--
-- BBT-BC MUX16 {1,4,5,5} mapped to gates.
-- see BBT_MUX16B.svg

Library ieee;
    use ieee.std_logic_1164.all;
Library SLV;
    use SLV.SLV_def.all;
Library proasic3;
    use proasic3.all;

entity MUX16 is
  port(
    leaves : in SLV16;
    CTRL : in SLV4;
    root : out SL);
end MUX16;

architecture gates of MUX16 is
  signal L4 : SLV8;
  signal L3 : SLV4;
  signal L2 : SLV2;
begin
  l1a: entity MX2 port map(A=>L2(0), B=>L2(1), S=>CTRL(0), Y=>root);

  l2a: entity MX2 port map(A=>L3(0), B=>L3(1), S=>CTRL(1), Y=>L2(0));
  l2b: entity MX2 port map(A=>L3(2), B=>L3(3), S=>CTRL(3), Y=>L2(1));

  l3a: entity MX2 port map(A=>L4(0), B=>L4(1), S=>CTRL(2), Y=>L3(0));
  l3b: entity MX2 port map(A=>L4(2), B=>L4(3), S=>CTRL(2), Y=>L3(1));
  l3c: entity MX2 port map(A=>L4(4), B=>L4(5), S=>CTRL(2), Y=>L3(2));
  l3d: entity MX2 port map(A=>L4(6), B=>L4(7), S=>CTRL(1), Y=>L3(3));

  l4a: entity MX2 port map(A=>leaves( 0), B=>leaves( 1), S=>CTRL(3), Y=>L4(0));
  l4b: entity MX2 port map(A=>leaves( 2), B=>leaves( 3), S=>CTRL(3), Y=>L4(1));
  l4c: entity MX2 port map(A=>leaves( 4), B=>leaves( 5), S=>CTRL(3), Y=>L4(2));
  l4d: entity MX2 port map(A=>leaves( 6), B=>leaves( 7), S=>CTRL(3), Y=>L4(3));
  l4e: entity MX2 port map(A=>leaves( 8), B=>leaves( 9), S=>CTRL(1), Y=>L4(4));
  l4f: entity MX2 port map(A=>leaves(10), B=>leaves(11), S=>CTRL(1), Y=>L4(5));
  l4g: entity MX2 port map(A=>leaves(12), B=>leaves(13), S=>CTRL(2), Y=>L4(6));
  l4h: entity MX2 port map(A=>leaves(14), B=>leaves(15), S=>CTRL(2), Y=>L4(7));
end gates;
