-- YGREC8/VHDL/TAP/MUX64/MUX64_BBTclass-rev.vhdl
-- created mar. juil. 21 21:07:06 CEST 2020 by whygee@f-cpu.org
-- version mar. juil. 21 23:01:34 CEST 2020
-- version dim. août  2 01:01:08 CEST 2020 : reverse input bit order
-- version 20200806 : synthesis with Synplify
--
-- Released under the GNU AGPLv3 license
--
-- Another trivial MUX64 but more detailed than the behavioural.
-- Each level of the selection tree is simulated
-- and the input vector is reversed.
--
-- SYNTHESIS OK


Library ieee;
    use ieee.std_logic_1164.all;
Library SLV;
    use SLV.SLV_def.all;

entity MUX64 is
  port(
    leaves : in SLV64;
    CTRL : in SLV6;
    root : out SL);
end MUX64;

architecture classic of MUX64 is
  signal L6 : SLV32;
  signal L5 : SLV16;
  signal L4 : SLV8;
  signal L3 : SLV4;
  signal L2 : SLV2;
begin
  root <=   L2(           1) when CTRL(0)/='1' else     L2(          0);
  L2 <=     L3( 3 downto  2) when CTRL(1)/='1' else     L3( 1 downto 0);
  L3 <=     L4( 7 downto  4) when CTRL(2)/='1' else     L4( 3 downto 0);
  L4 <=     L5(15 downto  8) when CTRL(3)/='1' else     L5( 7 downto 0);
  L5 <=     L6(31 downto 16) when CTRL(4)/='1' else     L6(15 downto 0);
  L6 <= leaves(63 downto 32) when CTRL(5)/='1' else leaves(31 downto 0);
end classic;

