# YGREC8/VHDL/TAP/MUX64/test.sh
# version mer. juil. 22 19:04:21 CEST 2020

PA3="-P../../gates -P../../shared"

function run_test() {
  # arg.1 : file/version
  # arg.2 : message
  echo -n "testing MUX64 $2 : "
  rm -f test_mux64 work-obj93.cf *.o
  ghdl -a $PA3 $1 test_MUX64.vhdl &&
  ghdl -e $PA3 test_mux64 &&
  ./test_mux64
}

function check_depth() {
  ghdl -a $PA3 Wrap_MUX64.vhdl ../../proasic3v3/VectGen.vhdl &&
  ghdl -e $PA3 VectGen &&
  echo &&
  ./vectgen |\
     sed 's/.*report note)://; /      0 -/d' |\
     sed -n '/Fanout:  Count:/,$p;' |\
     sed '/:/!Q' && # keep only the fanout histogram
  echo $1
}

# some tests are skipped because not really relevant and the script runtime could be shortened.
# keep these lines anyway to investigate regressions or redesigns.
#run_test MUX64_behavioral.vhdl               " behavioral" && echo "OK" &&
#run_test MUX64_behav-rev.vhdl                " behav-rev " && echo "OK" &&
#run_test MUX64_BBTclassic.vhdl               "   classic " && echo "OK" &&
#run_test MUX64_BBTclass-rev.vhdl             "classic-rev" && echo "OK" &&
#run_test MUX64_BBTgates.vhdl                 "   gates   " && check_depth '{ 1,  2,  4,  8, 16, 32 } : not good !' &&
#run_test "MUX16_A.vhdl MUX64_BBTBC.vhdl"     "  balanced " && check_depth '{ 1, 12, 12, 12, 13, 13 } : great !' &&
#run_test "MUX16_B.vhdl MUX64_BBTBC.vhdl"     " modified B" && check_depth '{ 1, 11, 11, 11, 11, 18 } : less good' &&
#run_test "MUX16_C.vhdl MUX64_BBTBC.vhdl"     " modified C" && check_depth '{ 1, 10, 10, 12, 12, 18 } : even less good' &&
#run_test "MUX16_B.vhdl MUX64_BBTm.vhdl"      "suboptimalB" && check_depth '{ 1, 11, 11, 11, 14, 15 } : good' &&
#run_test "MUX16_C.vhdl MUX64_BBTm.vhdl  "    "suboptimalC" && check_depth '{ 1, 11, 11, 11, 14, 15 } : good (too)' &&
#run_test "MUX16_Brev.vhdl MUX64_BBTrev.vhdl" "subopt-revB" && check_depth '{ 1, 11, 11, 11, 14, 15 } : good' &&
#the favorite one:
 run_test "MUX16_Crev.vhdl MUX64_BBTrev.vhdl" "subopt-revC" && check_depth '{ 1, 11, 11, 11, 14, 15 } : good' &&

echo $'\e[32m'" * MUX64 OK ! *"$'\e[0m'
