# YGREC8/VHDL/TAP/test.sh
# version mer. juil. 22 21:21:51 CEST 2020
# version  jeu. août  6 09:22:33 CEST 2020 : better error handling

#PA3="-P../gates/simple -P../shared"
PA3="-P../gates -P../shared"

echo -n "testing TAP : "
rm -f work-obj93.cf *.o test_readback piso_order

#MUXES="MUX64/MUX64_behav-rev.vhdl                    Gray6s/Gray6s_behavioral.vhdl"  # FAST sim but not efficient in silicon
#MUXES="MUX64/MUX64_BBTclass-rev.vhdl                 Gray6s/Gray6s_behavioral.vhdl"  # for sim only
#MUXES="MUX64/MUX16_Brev.vhdl MUX64/MUX64_BBTrev.vhdl Gray6s/Gray6s_tiles.vhdl" # OK - favorite
 MUXES="MUX64/MUX16_Crev.vhdl MUX64/MUX64_BBTrev.vhdl Gray6s/Gray6s_tiles.vhdl" # OK - alternative but slow sim
         # with the full-details gates, use the "simple" version instead

ghdl -a $PA3 $MUXES TAP.vhdl test_PISO_order.vhdl &&
ghdl -e $PA3 piso_order &&

# Output the permutation vector :
./piso_order -gverbose=2 > PISO_permutation.out &&
#./test_tap -gverbose=3 > SOPI_permutation.out (not used)

echo -n "Bit ordering : " &&
# ensure bit 63 comes first,
# so the RUN flag is available without shifting
grep '^63, ' PISO_permutation.out &&

echo "Checking readback..." &&
ghdl -a $PA3 ../shared/LFSR/lfsr_64.vhdl test_readback.vhdl &&
ghdl -e $PA3 test_readback &&
./test_readback &&

echo $'\e[32m'" * TAP OK ! *"$'\e[0m'
