#!/bin/bash
# A3Pv2.8/proasic3v3/build.sh
# version dim. déc. 29 20:03:56 2019
# version lun. mars 23 03:04:31 2020
# version jeu. jul. 16 01:38:59 2020 : added aliases.vhdl
# version dim. août 16 06:23:19 2020 : added the "simple" version in its own directory.
# version dim. nov. 14 06:57:43 CET 2021 : split the libraries conversions and SLV

VER="--std=93"

# some cleanup :
rm -rf *.cf *.o gategen PA3_components.vhdl PA3_definitions.vhdl simple &&

# First, compile the common stuff to their own working space
ghdl -a $VER --work=conversions    conversions.vhdl &&
ghdl -a $VER --work=SLV            SLV_def.vhdl &&
ghdl -a $VER --work=Histo          Histograms.vhdl &&

# compile the "gate generator":
ghdl -a $VER --work=proasic3 PA3_genlib.vhdl gategen.vhdl  &&
ghdl -e $VER --work=proasic3 gategen &&

# run and generate the whole gates:
./gategen -ggate_delay="1 ns" &&

# now compile the library :
ghdl -a $VER --work=proasic3 PA3_definitions.vhdl PA3_components.vhdl \
  PA3_combi.vhdl aliases.vhdl SRFF_PA3.vhdl &&

mkdir simple &&
pushd simple &&
  ln -s ../slv-obj93.cf         &&
  ln -s ../SLV_def.vhdl         &&
  ln -s ../SLV_def.o            &&
  ln -s ../conversions.o        &&
  ln -s ../conversions-obj93.cf &&
  ln -s ../conversions.vhdl     &&
  # re-run the "gate generator" but with a different option
  ../gategen -ggate_type="simple" &&
  ghdl -a $VER -P.. --work=proasic3 PA3_definitions.vhdl \
    PA3_components.vhdl ../PA3_combi.vhdl ../aliases.vhdl ../SRFF_simple.vhdl &&
popd &&

echo $'\e[32m'"Library generation : OK"$'\e[0m'

# note : compile VectGen.vhdl separately, in work
