-- file YGREC8/MISC/dictionary_tb.vhdl
-- created lun. nov.  8 08:21:22 CET 2021  by Yann Guidon / ygdes.com
--
-- A half-dumb key-value store.

Library dictionary;
    use dictionary.dictionary.all;


entity dictionary_tb is
end dictionary_tb;

architecture tb of dictionary_tb is
begin

  bench: process
    variable i   : integer := 0;
    variable DTP : DictTypePtr;
    variable DEP : DictEntryPtr;

  begin
    DTP := CreateDictionary;

    FindKey(DTP, string'("PLOP"), DEP);
    assert DEP=NULL report "test1: absent value is not NULL" severity FAILURE;

    AddKey(DTP, string'("PLOP"), DEP);
    assert DEP/=NULL report "test2: value should not be absent" severity FAILURE;
    DEP.EntryValue := 42;
    DumpKeys(DTP);

    FindKey(DTP, string'("PLOP"), DEP);
    assert DEP/=NULL report "test3: value should not be absent" severity FAILURE;

    FindKey(DTP, string'("PLUP"), DEP);
    assert DEP=NULL report "test4: absent value is not NULL" severity FAILURE;

--    FindKey(DTP, string'("pLUP"), DEP); -- Trigger an out-of-range error

    FreeDict(DTP);
    wait;
  end process;

end tb;

