#!/bin/bash
# A3Pv2.6/tests/Y8/build.sh
# version dim. déc. 29 20:13:34 CET 2019

VER="--std=93"
PA3="-P../gates"

# some cleanup :
rm -f *.cf *.o dictionary_tb hyx_tb hyx_tb*.hyx &&

# First, compile the common stuff to their own working space
#  so GHDL can access them easily with the -P parameter
#ghdl -a $VER --work=SLV            SLV_def.vhdl &&     moved to ../proasic3v3
#ghdl -a $VER --work=conversions    conversions.vhdl &&
ghdl -a $VER $PA3 --work=read_integers  read_integers.vhdl &&
ghdl -a $VER $PA3 --work=hyx            hyx_filters.vhdl  &&
ghdl -a $VER $PA3 --work=dictionary     dictionary.vhdl &&
ghdl -a $VER $PA3 --work=YGREC8         YGREC8_def.vhdl &&

# run some basic tests
ghdl -a $VER $PA3 hyx_tb.vhdl &&
ghdl -e      $PA3 hyx_tb &&
./hyx_tb && echo $'\e[32m'"Hyx filter test: OK "$'\e[0m' &&

ghdl -a $VER $PA3 dictionary_tb.vhdl &&
ghdl -e      $PA3 dictionary_tb &&
if ./dictionary_tb | grep -v '(report note)' ; then
  echo $'\e[91m'"Test dictionary : BORK !"$'\e[0m'
  false
else
  echo $'\e[32m'"Dictionary test: OK "$'\e[0m' &&
  rm dictionary_tb hyx_tb hyx_tb*.hyx
fi
