#!/bin/bash
# YGREC8/test_units.sh
# created lun. nov. 13 01:55:52 CET 2017 by Yann Guidon (whygee@f-cpu.org)
# version ven. nov. 17 01:11:13 CET 2017
# version lun. déc. 30 04:22:19 CET 2019
# version dim. mars 29 07:52:30 CEST 2020 clean break on first error
# version dim. nov. 14 05:28:25 CET 2021
#
# Released under the GNU AGPLv3 license

if ghdl -v |grep "mcode" ; then
  echo "This script does not support mcode, use GHDL with GCC or LLVM backend."
else

  echo
  echo  'This script will run exhaustive self-tests and will take "a while".'
  echo  'Like, up to one minute, depending on your CPU, options and software.'
  echo  'You may interrupt it (CTRL+C) if needed. Please report errors.'
  echo

  msg=$'\e[32m'"Source code set up and tested."$'\e[0m'
  for DIR in generics proasic3v3 shared ASM FSM \
              INC8 TAP/MUX64 TAP/Gray6s TAP/Selector \
              TAP ALU8 # TAP/Slice R7 SHL8 CORE
  do
    echo -n '--> going to ' ; pushd $DIR
    ./test.sh || { msg=$'\e[91m'" test_units.sh interrupted by fault"$'\e[0m'; break; }
    echo -n '<-- back from ' ; popd
  done
  echo $msg
fi
